{* <!-- макет страницы без центральной части --> *}{strip}

    {* <!-- =======================================================================
    |                                                                             |
    |  Проверяем неучтенные случаи "Ошибка 404".                                  |
    |                                                                             |
    ======================================================================== --> *}

    {include 'common/check404.htm'}

    {* <!-- =======================================================================
    |                                                                             |
    |  Непосредственно разметка.                                                  |
    |                                                                             |
    ======================================================================== --> *}

<!DOCTYPE HTML>
    <html>
        <head>
            <base href="{site}" />
            <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />

            {* <!-- ===============================================================
            |                                                                     |
            |  Задаем ожидаемый размер экрана смартфона:                          |
            |                                                                     |
            |      width=NNN                имитировать ширину NNN пикселей       |
            |      height=NNN               имитировать высоту NNN пикселей       |
            |                                                                     |
            |      width=device-width       подстроиться под текущую ширину       |
            |      height=device-height     подстроиться под текущую высоту       |
            |                                                                     |
            ================================================================ --> *}

            <meta name="viewport" content="width=580, height=840, initial-scale=1" />

            {* <!-- ===============================================================
            |                                                                     |
            |  Мета заголовок, ключи, описание.                                   |
            |                                                                     |
            ================================================================ --> *}

            <title>{title}</title>
            <meta content="{inputValue from=description}" name="Description" />
            <meta content="{inputValue from=keywords}" name="Keywords" />

            {* <!-- ===============================================================
            |                                                                     |
            |  Ярлыковая иконка.                                                  |
            |                                                                     |
            ================================================================ --> *}

            <link href="{theme}images/favicon.ico" rel="icon" type="image/vnd.microsoft.icon" />
            <link href="{theme}images/favicon.ico" rel="icon" type="image/x-icon" />
            <link href="{theme}images/favicon.ico" rel="shortcut icon" type="image/x-icon" />

            {* <!-- ===============================================================
            |                                                                     |
            |  Метка генератора страницы.                                         |
            |                                                                     |
            ================================================================ --> *}

            {$verMM = $smarty.const.IMPERA_CMS_CURRENT_MMVERSION|default:''}
            {$verYMD = $smarty.const.IMPERA_CMS_CURRENT_VERSION|default:''}
            <meta name="author" content="Impera CMS" />
            <meta name="generator" content="Impera CMS {$verMM} ({$verYMD})" />

            {* <!-- ===============================================================
            |                                                                     |
            |  Стили.                                                             |
            |                                                                     |
            ================================================================ --> *}

            <link href="{theme}css/style.css" rel="stylesheet" type="text/css" />

            {* <!-- ===============================================================
            |                                                                     |
            |  Скрипты. Сервис Google PageSpeed Insights рекомендует перенести    |
            |  подключение скрипта в конец верстки, прямо перед закрывающим тегом |
            |  </body>, чтобы ускорить отображение страницы. Тогда следует        |
            |  упредить срабатывание onclick-обработчиков до момента загрузки     |
            |  скрипта.                                                           |
            |                                                                     |
            |  ------------------------------------------------------------------ |
            |                                                                     |
            |  Традиционное подключение скрипта:                                  |
            |                                                                     |
            |      <script src="{theme}js/script.js"></script>                    |
            |                                                                     |
            |  ------------------------------------------------------------------ |
            |                                                                     |
            |  Иной путь ускорить страницу - подключать скрипт как файл шаблона,  |
            |  например:                                                          |
            |                                                                     |
            |      <script> {include '../js/script.js'} </script>                 |
            |                                                                     |
            |  При этом папка js должна быть в списке доверенных папок Smarty     |
            |  шаблонизатора (по умолчанию - не доверенная) и также обратите      |
            |  внимание на наличие тегов {literal} {/literal} по краям скрипта,   |
            |  чтобы исключить интерпретацию тела скрипта как Smarty-кода.        |
            |                                                                     |
            ================================================================ --> *}

            <script src="{theme}js/script.js"></script>

            {* <!-- ===============================================================
            |                                                                     |
            |  Основной модуль мог попросить добавить некоторые мета-теги.        |
            |                                                                     |
            ================================================================ --> *}

            {echoVar from=meta}
        </head>

        <body>
            <div id="wrapper">

                {* <!-- ===========================================================
                |                                                                 |
                |  Шапка.                                                         |
                |                                                                 |
                ============================================================ --> *}

                <div id="header">
                    <a href="{site}"><img id="logo" src="{theme}images/logo.png" alt="" /></a>

                    <form action="search" id="search" method="post">
                        <input name="keyword" type="text" value="{inputValue from=keyword}" maxlength="48" placeholder="что найти..." data-theme="{theme}" required />
                        <input name="reset_old" type="hidden" value="1" />
                        <a class="close restore" onclick="openResultsBox(this)">?</a>
                    </form>
                </div>

                {* <!-- ===========================================================
                |                                                                 |
                |  Контент основного модуля.                                      |
                |                                                                 |
                ============================================================ --> *}

                <div id="content">
                    {content}
                </div>

                {* <!-- ===========================================================
                |                                                                 |
                |  Результаты автозавершителя поиска.                             |
                |                                                                 |
                ============================================================ --> *}

                <div id="results"></div>

                {* <!-- ===========================================================
                |                                                                 |
                |  Окно оформления покупки.                                       |
                |                                                                 |
                ============================================================ --> *}

                {include 'fulminant.order.tpl' quick_content=FALSE}

                {* <!-- ===========================================================
                |                                                                 |
                |  Категории.                                                     |
                |                                                                 |
                ============================================================ --> *}

                <div id="categories">
                    <h6>
                        <a class="close" onclick="toggleAnnotationBox(this)" title="О наших товарах">?</a>
                        <a class="close left" onclick="closeCategoriesBox(this, false)">×</a>
                        <a class="close" href="products">Каталог</a>

                        Товары по разделам
                    </h6>

                    {* <!-- =======================================================
                    |                                                             |
                    |  Краткое описание.                                          |
                    |                                                             |
                    ======================================================== --> *}

                    <div class="annotation">
                        <a class="close" onclick="toggleAnnotationBox(this)">×</a>
                        Здесь можете написать несколько слов о ваших товарах.
                    </div>

                    {* <!-- =======================================================
                    |                                                             |
                    |  Если еще нет списка категорий (упреждающее чтение могло    |
                    |  быть запрещено настройками в файле helper.php шаблона),    |
                    |  тогда читаем.                                              |
                    |                                                             |
                    ======================================================== --> *}

                    {if !isset($categories)}
                        {categories assign=categories}
                    {/if}

                    {* <!-- =======================================================
                    |                                                             |
                    |  Выводим список (только первый уровень категорий).          |
                    |                                                             |
                    ======================================================== --> *}

                    {if !empty($categories)}
                        {foreach $categories as $item}
                            <a class="button" href="{url}">{name}</a>
                        {/foreach}
                    {/if}

                    {* <!-- =======================================================
                    |                                                             |
                    |  Ссылка на бренды.                                          |
                    |                                                             |
                    ======================================================== --> *}

                    <hr />
                    <a class="button" onclick="openCategoriesBox(true)">Производители</a>

                    {* <!-- =======================================================
                    |                                                             |
                    |  Всякие вспомогательные ссылки.                             |
                    |                                                             |
                    ======================================================== --> *}

                    <br class="clear" />
                    <a class="inline" href="news">Новости</a> &nbsp; | &nbsp; {**}
                    <a class="inline" href="feedback">Обратная связь</a> &nbsp; | &nbsp; {**}
                    <a class="inline" href="callme">Обратный звонок</a> &nbsp; | &nbsp; {**}
                    <a class="inline" href="articles">Обзоры</a>
                </div>

                {* <!-- ===========================================================
                |                                                                 |
                |  Бренды.                                                        |
                |                                                                 |
                ============================================================ --> *}

                <div id="brands">
                    <h6>
                        <a class="close" onclick="toggleAnnotationBox(this)" title="О производителях">?</a>
                        <a class="close left" onclick="closeCategoriesBox(this, true)">×</a>
                        <a class="close" href="products">Каталог</a>

                        Товары по производителям
                    </h6>

                    {* <!-- =======================================================
                    |                                                             |
                    |  Краткое описание.                                          |
                    |                                                             |
                    ======================================================== --> *}

                    <div class="annotation">
                        <a class="close" onclick="toggleAnnotationBox(this)">×</a>
                        Здесь можете написать несколько слов о производителях, чьи товары вы продаёте.
                    </div>

                    {* <!-- =======================================================
                    |                                                             |
                    |  Если еще нет списка брендов (упреждающее чтение могло быть |
                    |  запрещено настройками в файле helper.php шаблона), тогда   |
                    |  читаем.                                                    |
                    |                                                             |
                    ======================================================== --> *}

                    {if !isset($all_brands)}
                        {categories table=brands assign=all_brands}
                    {/if}

                    {* <!-- =======================================================
                    |                                                             |
                    |  Выводим список.                                            |
                    |                                                             |
                    ======================================================== --> *}

                    {if !empty($all_brands)}
                        {foreach $all_brands as $item}
                            <a class="button" href="{url}">{name}</a>
                        {/foreach}
                    {/if}

                    {* <!-- =======================================================
                    |                                                             |
                    |  Ссылка на категории.                                       |
                    |                                                             |
                    ======================================================== --> *}

                    <hr />
                    <a class="button" onclick="openCategoriesBox(false)">Разделы</a>

                    {* <!-- =======================================================
                    |                                                             |
                    |  Всякие вспомогательные ссылки.                             |
                    |                                                             |
                    ======================================================== --> *}

                    <br class="clear" />
                    <a class="inline" href="news">Новости</a> &nbsp; | &nbsp; {**}
                    <a class="inline" href="feedback">Обратная связь</a> &nbsp; | &nbsp; {**}
                    <a class="inline" href="callme">Обратный звонок</a> &nbsp; | &nbsp; {**}
                    <a class="inline" href="articles">Обзоры</a>
                </div>

                {* <!-- ===========================================================
                |                                                                 |
                |  Подвал (строка из конфигурационного параметра phone1).         |
                |                                                                 |
                ============================================================ --> *}

                <div id="footer">
                    <div id="phone">{echoVar from='config->phone1' def='создайте phone1'}</div>

                    {* <!-- =======================================================
                    |                                                             |
                    |  Имя сайта (из настроек) + счетчики (скрипты метрики,       |
                    |  аналитики Гугл и т.п., указанные в настройках сайта).      |
                    |                                                             |
                    ======================================================== --> *}

                    © {echoVar from='settings->site_name' def='Без названия!'}
                    <div id="counters">{echoVar from='settings->counters'}</div>

                    {* <!-- =======================================================
                    |                                                             |
                    |  Авторские ссылки.                                          |
                    |                                                             |
                    ======================================================== --> *}

                    <a class="cms" href="http://imperacms.ru/">Скрипт магазина</a>
                    <a class="designer" href="#">Дизайн: ИмяДизайнера</a>

                    {* <!-- =======================================================
                    |                                                             |
                    |  Строка из конфигурационного параметра RapidMobile_remark.  |
                    |                                                             |
                    ======================================================== --> *}

                    <div class="remark">
                        {echoVar from='config->RapidMobile_remark' def='Продажи в 3 клика!'}
                    </div>
                </div>
            </div>
        </body>
    </html>

{/strip}