{* <!-- страница оформленного заказа --> *}{strip}

    {* <!-- =======================================================================
    |                                                                             |
    |  Отправляем заголовок "Ошибка 404" (чтобы заказ не попал в поисковик).      |
    |                                                                             |
    ======================================================================== --> *}

    {header404}
    {$meta = '<meta name="Robots" content="noindex,follow" />' scope=global}

    {$title = 'Ваш заказ' scope=global}
    {$description = '' scope=global}
    {$keywords = '' scope=global}

    {* <!-- =======================================================================
    |                                                                             |
    |  Если заказ не скрыт от посторонних (в Impera CMS есть такая функция) или   |
    |  заказ смотрит админ.                                                       |
    |                                                                             |
    ======================================================================== --> *}

    {if !empty($order) && (empty($order->hidden) || $order->user_id|default:FALSE === $user->user_id|default:0 || $smarty.session.admin|default:'' == 'admin')}

        {* <!-- ===================================================================
        |                                                                         |
        |  Заголовок.                                                             |
        |                                                                         |
        ==================================================================== --> *}

        <h1>Заказ №{echoVar from='order->order_id'} от {echoVar from='order->date_date'}</h1>

        {* <!-- ===================================================================
        |                                                                         |
        |  Состояние заказа.                                                      |
        |                                                                         |
        ==================================================================== --> *}

        <div id="order" class="publication">
            <div class="status">
                {echoVar from='order->status' assign=status}
                Статус: {if empty($order->payment_status)}еще не{/if} оплачен,
                        {if $status == 0} ждет обработки
                        {elseif $status == 1} в обработке
                        {elseif $status == 2} выполнен
                        {elseif $status == 3} аннулирован
                        {else} статус неизвестный!{/if}
            </div>

            {* <!-- ===============================================================
            |                                                                     |
            |  Стадия состояния заказа.                                           |
            |                                                                     |
            ================================================================ --> *}

            {if !empty($order->orders_phase)}
                <div class="status">Стадия выполнения: {$order->orders_phase}</div>
            {/if}

            {* <!-- ===============================================================
            |                                                                     |
            |  Товары заказа.                                                     |
            |                                                                     |
            ================================================================ --> *}

            <table cellspacing="0" width="100%">
                <tr>
                    <th colspan="2">Товар</th>
                    <th nowrap>Кол-во</th>
                    <th>Сумма</th>
                </tr>

                {if !empty($order->products)}
                    {foreach $order->products as $item}
                        <tr class="item">

                            {* <!-- ===============================================
                            |                                                     |
                            |  Фотография.                                        |
                            |                                                     |
                            ================================================ --> *}

                            <td><img src="{image folder='files/products'}" alt="" /></td>

                            {* <!-- ===============================================
                            |                                                     |
                            |  Название товара, ссылка.                           |
                            |                                                     |
                            ================================================ --> *}

                            <td width="100%">
                                <a href="{url}">{name}</a> {**}

                                {* <!-- ===========================================
                                |                                                 |
                                |  Название варианта товара.                      |
                                |                                                 |
                                ============================================ --> *}

                                {if !empty($item->variant_name)}
                                    <span class="variant">{inputValue from='item->variant_name'}</span> {**}
                                {/if}

                                {* <!-- ===========================================
                                |                                                 |
                                |  Отобранные покупателем свойства товара.        |
                                |                                                 |
                                ============================================ --> *}

                                {if !empty($r->name_properties)}
                                    <span class="properties">{$r->name_properties}</span> {**}
                                {/if}

                                {* <!-- ===========================================
                                |                                                 |
                                |  Если этот товар под заказ и в настройках сайта |
                                |  заполнен ремарочный текст.                     |
                                |                                                 |
                                ============================================ --> *}

                                {if $item->quantity <= 0 && !empty($settings->cart_reservation_text)}
                                    <div class="reservation">{$settings->cart_reservation_text}</div>
                                {/if}
                            </td>

                            {* <!-- ===============================================
                            |                                                     |
                            |  Количество, сумма.                                 |
                            |                                                     |
                            ================================================ --> *}

                            {$amount = ($item->quantity < 0) ? $item->quantity * -1 : $item->quantity}
                            <td nowrap>{$amount} шт.</td>
                            <td nowrap>{$helper->priceForScreen($item->price * $amount)} {sign}</td>
                        </tr>
                    {/foreach}
                {/if}

                {* <!-- ===========================================================
                |                                                                 |
                |  Итого.                                                         |
                |                                                                 |
                ============================================================ --> *}

                <tr class="total">
                    <td colspan="3">Игото</td>
                    <td nowrap>{$helper->priceForScreen($order->total_amount)} {sign}</td>
                </tr>
            </table>

            {* <!-- ===============================================================
            |                                                                     |
            |  Комментарий менеджера.                                             |
            |                                                                     |
            ================================================================ --> *}

            {if !empty($order->comment_status)}
                <div class="comment"><b>Заметки менеджера:</b> {$order->comment_status}</div>
            {/if}

            {* <!-- ===============================================================
            |                                                                     |
            |  Код отслеживания груза.                                            |
            |                                                                     |
            ================================================================ --> *}

            {if !empty($order->delivery_tracking)}
                <div class="tracking"><b>Отслеживание груза:</b> {$order->delivery_tracking}</div>
            {/if}

            {* <!-- ===============================================================
            |                                                                     |
            |  Способы оплаты (если заказ не оплачен).                            |
            |                                                                     |
            ================================================================ --> *}

            {if empty($order->payment_status)}
                {if !empty($PaymentMethods)}
                    {echoVar from='order->desire_payment_id' assign=selectedId}

                    <a name="payments"></a>
                    {foreach $PaymentMethods as $item}

                        {* <!-- ===================================================
                        |                                                         |
                        |  Название, финальная сумма, валюта.                     |
                        |                                                         |
                        ==================================================== --> *}

                        <h4>Оплата: {name}, {$helper->priceForScreen($item->amount, FALSE)} {echoVar from='item->currency_sign'}</h4>

                        {* <!-- ===================================================
                        |                                                         |
                        |  Этим ли способом предполагал платить?                  |
                        |                                                         |
                        ==================================================== --> *}

                        {echoVar from='item->payment_method_id' assign=id}
                        {if $id === $selectedId}
                            <div>Вы хотели оплатить этим способом.</div>
                        {/if}

                        {* <!-- ===================================================
                        |                                                         |
                        |  Кнопка оплаты.                                         |
                        |                                                         |
                        ==================================================== --> *}

                        {if !empty($item->payment_button)}
                            <div class="payment">{$item->payment_button}</div>
                        {/if}

                        {* <!-- ===================================================
                        |                                                         |
                        |  Описание.                                              |
                        |                                                         |
                        ==================================================== --> *}

                        {if !empty($item->description)}
                            <div class="description">{$item->description}</div>
                        {/if}
                    {/foreach}
                {/if}
            {/if}
        </div>

    {* <!-- =======================================================================
    |                                                                             |
    |  Иначе заказа нет или скрыт от посторонних.                                 |
    |                                                                             |
    ======================================================================== --> *}

    {else}
        <h1>Страница не найдена!</h1>
        <div class="error">Нет такого заказа!</div>
    {/if}

{/strip}