{* <!-- страница товара --> *}{strip}

    {* <!-- =======================================================================
    |                                                                             |
    |  Готовим переменные для упрощения кода (название товара, идентификатор      |
    |  товара, имя CSS-класса для внешнего вида карточки товара).                 |
    |                                                                             |
    ======================================================================== --> *}

    {name from=product assign=model}
    {inputValue from='product->product_id' assign=pid}
    {inputValue from=subclass assign=subclass}

    {* <!-- =======================================================================
    |                                                                             |
    |  Карточка товара.                                                           |
    |                                                                             |
    ======================================================================== --> *}

    <div class="product {$subclass}" onclick="selectThisProduct(this, '{$subclass}')">

        {* <!-- ===================================================================
        |                                                                         |
        |  Фотографии товара (первую выводим в любом случае, даже если в ней      |
        |  "нет фото", и первая сразу активная). Если фотографий более 1, выводим |
        |  кнопки "назад-вперед" и число фотографий.                              |
        |                                                                         |
        ==================================================================== --> *}

        <div class="image">
            {$class = 'class="active"'}
            {$number = 0}
            {section name=images loop=1000}
                {$number = $number + 1}

                {* <!-- ===========================================================
                |                                                                 |
                |  Найти фотографию с текущим номером (view='*' значит искать как |
                |  среди включенных, так и среди выключенных).                    |
                |                                                                 |
                ============================================================ --> *}

                {findImage from=product type=product num=$number view='*' assign=image}
                {if empty($image['found']) && $number > 1}
                    {$number = $number - 1}
                    {break}
                {/if}

                {* <!-- ===========================================================
                |                                                                 |
                |  Фото.                                                          |
                |                                                                 |
                ============================================================ --> *}

                <img {$class} src="{$image['url']}" title="{$model}" alt="{$image['alt']}" />
                {$class = ''}
            {/section}

            {* <!-- ===============================================================
            |                                                                     |
            |  Кнопки "назад-вперед", число фотографий.                           |
            |                                                                     |
            ================================================================ --> *}

            {if $number > 1}
                <a class="prev" onclick="showNextImage(this, false)" title="Предыдущая фотография">«</a>
                <span data-num="1">{$number}</span>
                <a class="next" onclick="showNextImage(this, true)" title="Следующая фотография">»</a>
            {/if}
        </div>

        {* <!-- ===================================================================
        |                                                                         |
        |  Название + кнопки "закрыть / открыть".                                 |
        |                                                                         |
        ==================================================================== --> *}

        <h1>
            <a class="close" onclick="event.stopPropagation(); toggleAnnotationBox(this)" title="Описание товара">?</a>
            {if !empty($subclass)}
                <a class="close left" onclick="event.stopPropagation(); unselectThisProduct(this, '{$subclass}')">×</a>
            {else}
                <a class="close" onclick="event.stopPropagation(); openCategoriesBox(false)">Разделы</a>
            {/if}

            {$model}
        </h1>

        {* <!-- ===================================================================
        |                                                                         |
        |  Код товара.                                                            |
        |                                                                         |
        ==================================================================== --> *}

        <div class="pcode">
            Код: {$product->pcode|default:'--/--'}
        </div>

        {* <!-- ===================================================================
        |                                                                         |
        |  Краткое описание товара.                                               |
        |                                                                         |
        ==================================================================== --> *}

        <div class="annotation">
            <a class="close" onclick="toggleAnnotationBox(this)">×</a>
            {annotation from=product}
        </div>

        {* <!-- ===================================================================
        |                                                                         |
        |  Характеристики товара.                                                 |
        |                                                                         |
        ==================================================================== --> *}

        {if !empty($product->properties_tree)}
            <ul class="properties">
                {foreach $product->properties_tree as $value}
                    {$item = reset($value)}
                    {if !empty($item->in_product)}
                        <li>{name}: <span>{$item->value|default:'-'}</span></li>
                    {/if}
                {/foreach}
            </ul>
        {/if}

        {* <!-- ===================================================================
        |                                                                         |
        |  Варианты товара.                                                       |
        |                                                                         |
        ==================================================================== --> *}

        <span class="variants">
            {randomId assign=unique}
            {$vid = []}
            {$variant = []}
            {$sku = []}
            {$number = 1}

            {if !empty($product->variants)}
                {foreach $product->variants as $item}

                    {* <!-- =======================================================
                    |                                                             |
                    |  Запоминаем ИД варианта товара, название варианта, артикул  |
                    |  (в самом низу нам понадобятся данные первого варианта).    |
                    |                                                             |
                    ======================================================== --> *}

                    {$vid[$number] = $item->variant_id|default:''|escape}
                    {$variant[$number] = $item->variant_name|default:''|escape}
                    {$sku[$number] = $item->sku|default:'--/--'|escape}

                    {* <!-- =======================================================
                    |                                                             |
                    |  Радио-инпут, цена с учетом скидки, название, артикул (при  |
                    |  клике инпута скрипт будет копировать эти сведения в data-  |
                    |  атрибуты кнопки "Купить" ниже).                            |
                    |                                                             |
                    ======================================================== --> *}

                    <label class="variant">
                        <input name="product{$pid}-{$unique}" type="radio" {($number == 1) ? "checked" : ""} onchange="return changeProductVariant(this)" value="{$vid[$number]}" />
                        <span class="price">{discountPrice from=product num=$number}</span>
                        <span class="name">{$variant[$number]}</span>
                        <span class="sku"> {$sku[$number]}</span>
                    </label>

                    {$number = $number + 1}
                {/foreach}
            {/if}
        </span>

        {* <!-- ===================================================================
        |                                                                         |
        |  Кнопка "Купить" (для скрипта в атрибутах data- сохраняем сведения о    |
        |  выбранном варианте - сейчас это первый вариант).                       |
        |                                                                         |
        ==================================================================== --> *}

        <a class="button" href="{url from=product}" onclick="event.stopPropagation(); jQuery(this).removeAttr('href'); return openBuyProductForm(this);" data-pid="{$pid}" data-vid="{$vid[1]}" data-price="{discountPrice from=product}" data-product="{$model}" data-variant="{$variant[1]}" data-sku="{$sku[1]}">Купить</a>
    </div>

{/strip}