{* <!-- страница категории / бренда --> *}{strip}

    {* <!-- =======================================================================
    |                                                                             |
    |  Вычислим признак "это обычная страница": TRUE если категория / бренд       |
    |  имеет выключенный флажок "информативная".                                  |
    |                                                                             |
    ======================================================================== --> *}

    {$normalPage = empty($category->informative) && empty($brand->informative)}

    {* <!-- =======================================================================
    |                                                                             |
    |  Вычислим признак "сейчас на странице выведено описание": TRUE если это     |
    |  обычная страница, и мы на первой странице списка, и в категории / бренде   |
    |  заполнено поле "описание".                                                 |
    |                                                                             |
    ======================================================================== --> *}

    {$annotatedPage = $normalPage && empty($CurrentPage) && (!empty($brand->description) || !empty($category->description))}

    {* <!-- =======================================================================
    |                                                                             |
    |  Название КАТЕГОРИЯ БРЕНД или КАТАЛОГ (например на http://сайт/products)    |
    |  + кнопка "открыть описание" + кнопка "открыть список категорий" + кнопка   |
    |  "весь каталог".                                                            |
    |                                                                             |
    ======================================================================== --> *}

    <h1>
        {if $annotatedPage}
            <a class="close" onclick="toggleAnnotationBox(this)" title="Описание раздела">?</a>
        {/if}
        <a class="close" onclick="openCategoriesBox(false)">Разделы</a>
        <a class="close left" href="products" title="Весь каталог">≡</a>

        {if !empty($category->name) || !empty($brand->name)}
            {name from=category def=''} {name from=brand def=''}
        {else}
            Каталог
        {/if}
    </h1>

    {* <!-- =======================================================================
    |                                                                             |
    |  Если это обычная страница (не имеет включенный флажок "информативная").    |
    |                                                                             |
    ======================================================================== --> *}

    {if $normalPage}

        {* <!-- ===================================================================
        |                                                                         |
        |  Описание бренда / категории.                                           |
        |                                                                         |
        ==================================================================== --> *}

        {if $annotatedPage}
            {if !empty($brand->description)}
                <div class="annotation">
                    <a class="close" onclick="toggleAnnotationBox(this)">×</a>
                    {annotation from=brand}
                </div>

            {elseif !empty($category->description)}
                <div class="annotation">
                    <a class="close" onclick="toggleAnnotationBox(this)">×</a>
                    {annotation from=category}
                </div>
            {/if}
        {/if}

        {* <!-- ===================================================================
        |                                                                         |
        |  Список товаров (если непустой). Когда рисуем карточку товара, сообщаем |
        |  ей параметр subclass=listing для css-стилизации, чтобы была            |
        |  возможность отображать товары категории иначе, если потребуется.       |
        |                                                                         |
        ==================================================================== --> *}

        {if !empty($products)}
            <div class="products">
                {foreach $products as $product}
                    {include 'product.tpl' subclass=listing}
                {/foreach}

                {* <!-- ===========================================================
                |                                                                 |
                |  Пагинация страниц (сгенерирована файлом navigation.htm).       |
                |                                                                 |
                ============================================================ --> *}

                {echoVar from=PagesNavigation}

                {* <!-- ===========================================================
                |                                                                 |
                |  SEO текст бренда / категории (только на 1-ой странице списка). |
                |                                                                 |
                ============================================================ --> *}

                {if empty($CurrentPage)}
                    {include 'common/seo.htm' from=brand}
                    {include 'common/seo.htm' from=category}
                {/if}
            </div>

        {* <!-- ===================================================================
        |                                                                         |
        |  Иначе в категории / бренде нет товаров.                                |
        |                                                                         |
        ==================================================================== --> *}

        {else}
            <div class="error">Нет товаров!</div>
        {/if}

    {* <!-- =======================================================================
    |                                                                             |
    |  Иначе это информативная страница (только описание без показа товаров).     |
    |                                                                             |
    ======================================================================== --> *}

    {else}
        <div class="publication">
            {annotation from=category}
            {annotation from=brand}

            {* <!-- ===============================================================
            |                                                                     |
            |  SEO текст бренда / категории.                                      |
            |                                                                     |
            ================================================================ --> *}

            {include 'common/seo.htm' from=brand}
            {include 'common/seo.htm' from=category}
        </div>
    {/if}

{/strip}